#pragma once
#ifndef BINARY_C_PYTHON_H
#define BINARY_C_PYTHON_H

/*
 * Include binary_C's API
 */
#include "binary_c_API.h"
#include "binary_c_API_prototypes.h"

/* Binary_c's python API prototypes */
int run_binary(char * argstring,
                char ** const outstring,
                char ** const errorstring,
                size_t * const nbytes);

int run_binary_with_logfile(char * argstring,
                char ** const outstring,
                char ** const errorstring,
                size_t * const nbytes);

int run_binary_custom_logging(char * argstring,
               long int func_memaddr,
               char ** const buffer,
               char ** const error_buffer,
               size_t * const nbytes);

int return_arglines(char ** const outstring,
                char ** const errorstring,  
                size_t * const nbytes);

int return_help_info(char * argstring,
                char ** const outstring,
                char ** const errorstring,
                size_t * const nbytes);

int return_help_all_info(char ** const outstring,
                char ** const errorstring,
                size_t * const nbytes);

/* C macros */
#define BINARY_C_APITEST_VERSION 0.1
#define APIprint(...) APIprintf(__VA_ARGS__);
#define NO_OUTPUT

#endif // BINARY_C_C_PYTHON_H
